<script setup lang="ts">
import { reactive, onMounted, toRaw, ref, onBeforeUnmount } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { message, Modal } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/es/table';
import useDictStore from '@/store/modules/dict';
import useI18n from '@/hooks/useI18n';
import {
  RESULT_CODE_ERROR,
  RESULT_CODE_SUCCESS,
} from '@/constants/result-constants';
import useNeInfoStore from '@/store/modules/neinfo';
import {
  delSMSCDataCDR,
  exportSMSCDataCDR,
  listSMSCDataCDR,
} from '@/api/neData/smsc';
import { parseDateToStr } from '@/utils/date-utils';
import { OptionsType, WS } from '@/plugins/ws-websocket';
import saveAs from 'file-saver';
import PQueue from 'p-queue';
import { listTenant } from '@/api/system/tenant';
import { useClipboard } from '@vueuse/core';
import { hasPermissions } from '@/plugins/auth-user';
const { copy } = useClipboard({ legacy: true });
const { getDict } = useDictStore();
const { t } = useI18n();
const ws = new WS();
const queue = new PQueue({ concurrency: 1, autoStart: true });

/**字典数据 */
let dict: {
  /**CDR 响应原因代码类别类型 */
  cdrCauseCode: DictType[];
} = reactive({
  cdrCauseCode: [],
});

/**网元可选 */
let neOtions = ref<Record<string, any>[]>([]);

/**开始结束时间 */
let queryRangePicker = ref<[string, string]>(['', '']);

/**查询参数 */
let queryParams = reactive({
  tenantNameArr: <Record<string, any>[]>[],
  /**网元类型 */
  neType: 'SMSC',
  neId: '001',
  recordType: '',
  callerParty: '',
  calledParty: '',
  /** 租户名称*/
  tenantName: '',
  sortField: 'timestamp',
  sortOrder: 'desc',
  /**开始时间 */
  startTime: '',
  /**结束时间 */
  endTime: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  recordTypes.value = [];
  queryParams = Object.assign(queryParams, {
    recordType: '',
    callerParty: '',
    calledParty: '',
    /** 租户名称*/
    tenantName: '',
    startTime: '',
    endTime: '',
    pageNum: 1,
    pageSize: 20,
  });
  queryRangePicker.value = ['', ''];
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**记录类型 */
const recordTypes = ref<string[]>([]);

/**查询记录类型变更 */
function fnQueryRecordTypeChange(value: any) {
  if (Array.isArray(value)) {
    queryParams.recordType = value.join(',');
  }
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('common.rowId'),
    dataIndex: 'id',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.dashboard.cdr.recordType'),
    dataIndex: 'cdrJSON',
    align: 'left',
    width: 150,
    customRender(opt) {
      const cdrJSON = opt.value;
      return cdrJSON.recordType;
    },
  },
  {
    title: t('views.dashboard.cdr.type'),
    dataIndex: 'cdrJSON',
    align: 'left',
    width: 150,
    customRender(opt) {
      const cdrJSON = opt.value;
      return cdrJSON.serviceType;
    },
  },
  {
    title: t('views.dashboard.cdr.caller'),
    dataIndex: 'cdrJSON',
    key: 'callerParty',
    align: 'left',
    width: 150,
    customRender(opt) {
      const cdrJSON = opt.value;
      return cdrJSON.callerParty;
    },
  },
  {
    title: t('views.dashboard.cdr.called'),
    dataIndex: 'cdrJSON',
    key: 'calledParty',
    align: 'left',
    width: 150,
    customRender(opt) {
      const cdrJSON = opt.value;
      return cdrJSON.calledParty;
    },
  },

  {
    title: t('views.dashboard.cdr.result'),
    dataIndex: 'cdrJSON',
    key: 'cause',
    align: 'left',
    width: 200,
  },
  {
    title: t('views.dashboard.cdr.time'),
    dataIndex: 'cdrJSON',
    align: 'left',
    width: 200,
    customRender(opt) {
      const cdrJSON = opt.value;
      if (typeof cdrJSON.updateTime === 'number') {
        return parseDateToStr(+cdrJSON.updateTime * 1000);
      }
      return cdrJSON.updateTime;
    },
  },
  {
    title: t('views.dashboard.cdr.tenantName'),
    dataIndex: 'tenantName',
    align: 'center',
    key: 'tenantName',
    width: 150,
  },
  {
    title: t('common.operate'),
    key: 'id',
    align: 'left',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**表格多选 */
function fnTableSelectedRowKeys(keys: (string | number)[]) {
  tableState.selectedRowKeys = keys;
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**确定按钮 loading */
  confirmLoading: boolean;
  /**最大ID值 */
  maxId: number;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  confirmLoading: false,
  maxId: 0,
});

/**
 * 记录删除
 * @param id  编号
 */
function fnRecordDelete(id: string) {
  if (!id || modalState.confirmLoading) return;
  let msg = id;
  if (id === '0') {
    msg = `${id}...  ${tableState.selectedRowKeys.length}`;
    id = tableState.selectedRowKeys.join(',');
  }

  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.dashboard.cdr.delTip', { msg }),
    onOk() {
      modalState.confirmLoading = true;
      const hide = message.loading(t('common.loading'), 0);
      delSMSCDataCDR(id)
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.operateOk'),
              duration: 3,
            });
            fnGetList(1);
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
        });
    },
  });
}

/**
 * 复制CDR
 * @param jsonStr JSON字符串
 */
function fnRecordCopy(jsonStr: string) {
  if (!jsonStr) return;
  const text = JSON.stringify(jsonStr, null, 2);
  copy(text).then(() => {
    message.success(t('common.copyOk'), 3);
  });
}

/**查询列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  if (!queryRangePicker.value) {
    queryRangePicker.value = ['', ''];
  }
  queryParams.startTime = queryRangePicker.value[0];
  queryParams.endTime = queryRangePicker.value[1];
  listSMSCDataCDR(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      tablePagination.total = res.total;
      // 遍历处理cdr字符串数据
      tableState.data = res.rows.map(item => {
        let cdrJSON = item.cdrJSON;
        if (!cdrJSON) {
          Reflect.set(item, 'cdrJSON', {});
        }

        try {
          cdrJSON = JSON.parse(cdrJSON);
          Reflect.set(item, 'cdrJSON', cdrJSON);
        } catch (error) {
          console.error(error);
          Reflect.set(item, 'cdrJSON', {});
        }

        return item;
      });

      // 取最大值ID用作实时累加
      if (res.total > 0) {
        modalState.maxId = Number(res.rows[0].id);
      }
    }
    tableState.loading = false;
  });
}

/**列表导出 */
function fnExportList() {
  if (modalState.confirmLoading) return;
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.dashboard.cdr.exportTip'),
    onOk() {
      const hide = message.loading(t('common.loading'), 0);
      const querys = toRaw(queryParams);
      querys.pageSize = 10000;
      exportSMSCDataCDR(querys)
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.operateOk'),
              duration: 3,
            });
            saveAs(res.data, `smsc_cdr_event_export_${Date.now()}.xlsx`);
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
        });
    },
  });
}

/**实时数据开关 */
const realTimeData = ref<boolean>(false);

/**
 * 实时数据
 */
function fnRealTime() {
  realTimeData.value = !realTimeData.value;
  if (realTimeData.value) {
    tableState.seached = false;
    // 建立链接
    const options: OptionsType = {
      url: '/ws',
      params: {
        /**订阅通道组
         *
         * SMSC_CDR会话事件(GroupID:1007_neId)
         */
        subGroupID: `1007_${queryParams.neId}`,
      },
      onmessage: wsMessage,
      onerror: (ev: any) => {
        console.error(ev);
      },
    };
    ws.connect(options);
  } else {
    ws.close();
    tableState.seached = true;
    fnGetList(1);
  }
}

/**接收数据后回调 */
function wsMessage(res: Record<string, any>) {
  const { code, requestId, data } = res;
  if (code === RESULT_CODE_ERROR) {
    console.warn(res.msg);
    return;
  }

  // 订阅组信息
  if (!data?.groupId) {
    return;
  }
  // cdrEvent CDR会话事件
  if (data.groupId === `1007_${queryParams.neId}`) {
    const cdrEvent = data.data;
    queue.add(async () => {
      modalState.maxId += 1;
      tableState.data.unshift({
        id: modalState.maxId,
        neType: cdrEvent.neType,
        neName: cdrEvent.neName,
        rmUID: cdrEvent.rmUID,
        timestamp: cdrEvent.timestamp,
        cdrJSON: cdrEvent.CDR,
      });
      tablePagination.total += 1;
      if (tableState.data.length > 100) {
        tableState.data.pop();
      }
      await new Promise(resolve => setTimeout(resolve, 800));
    });
  }
}

onMounted(() => {
  // 初始字典数据
  Promise.allSettled([getDict('cdr_cause_code')]).then(resArr => {
    if (resArr[0].status === 'fulfilled') {
      dict.cdrCauseCode = resArr[0].value;
    }
  });
  // 获取网元网元列表
  useNeInfoStore()
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        if (res.data.length > 0) {
          let arr: Record<string, any>[] = [];
          res.data.forEach(i => {
            if (i.neType === 'SMSC') {
              arr.push({ value: i.neId, label: i.neName });
            }
          });
          neOtions.value = arr;
          if (arr.length > 0) {
            queryParams.neId = arr[0].value;
          }
        }
      } else {
        message.warning({
          content: t('common.noData'),
          duration: 2,
        });
      }
    })
    .finally(() => {
      // 获取列表数据
      fnGetList();
      //查询租户
      listTenant({ parentId: 0 }).then(res => {
        if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
          queryParams.tenantNameArr = []; //上面置为空数组时会报错 故在此
          res.data.forEach((item: any) => {
            if (item.parentId === '0') {
              queryParams.tenantNameArr.push({
                value: item.tenantName,
                label: item.tenantName,
              });
            }
          });
        }
      });
    });
});

onBeforeUnmount(() => {
  if (ws.state() !== -1) {
    ws.close();
  }
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item label="SMSC" name="neId ">
              <a-select
                v-model:value="queryParams.neId"
                :options="neOtions"
                :placeholder="t('common.selectPlease')"
                @change="fnQueryReset()"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.dashboard.cdr.called')"
              name="calledParty"
            >
              <a-input
                v-model:value="queryParams.calledParty"
                allow-clear
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.dashboard.cdr.caller')"
              name="callerParty "
            >
              <a-input
                v-model:value="queryParams.callerParty"
                allow-clear
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.dashboard.cdr.recordType')"
              name="recordType"
            >
              <a-select
                v-model:value="recordTypes"
                mode="multiple"
                :options="['MOSM', 'MTSM'].map(v => ({ value: v }))"
                :placeholder="t('common.selectPlease')"
                @change="fnQueryRecordTypeChange"
              ></a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="8" :md="12" :xs="24">
            <a-form-item
              :label="t('views.dashboard.cdr.time')"
              name="queryRangePicker"
            >
              <a-range-picker
                v-model:value="queryRangePicker"
                allow-clear
                bordered
                :show-time="{ format: 'HH:mm:ss' }"
                format="YYYY-MM-DD HH:mm:ss"
                value-format="x"
                style="width: 100%"
              ></a-range-picker>
            </a-form-item>
          </a-col>
          <a-col :lg="8" :md="12" :xs="24">
            <a-form-item
              :label="t('views.neUser.sub.tenantName')"
              name="tenantName "
            >
              <a-auto-complete
                v-model:value="queryParams.tenantName"
                :options="queryParams.tenantNameArr"
              ></a-auto-complete>
            </a-form-item>
          </a-col>

          <a-col :lg="4" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-popconfirm
            placement="bottomLeft"
            :title="
              !realTimeData
                ? t('views.dashboard.cdr.realTimeDataStart')
                : t('views.dashboard.cdr.realTimeDataStop')
            "
            ok-text="Yes"
            cancel-text="No"
            @confirm="fnRealTime()"
          >
            <a-button type="primary" :danger="realTimeData">
              <template #icon><FundOutlined /> </template>
              {{
                !realTimeData
                  ? t('views.dashboard.cdr.realTimeDataStart')
                  : t('views.dashboard.cdr.realTimeDataStop')
              }}
            </a-button>
          </a-popconfirm>

          <a-button
            type="default"
            danger
            :disabled="tableState.selectedRowKeys.length <= 0"
            :loading="modalState.confirmLoading"
            @click.prevent="fnRecordDelete('0')"
            v-perms:has="['cdr:ne:remove']"
          >
            <template #icon><DeleteOutlined /></template>
            {{ t('common.deleteText') }}
          </a-button>

          <a-button type="dashed" @click.prevent="fnExportList()">
            <template #icon><ExportOutlined /></template>
            {{ t('common.export') }}
          </a-button>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
              :disabled="realTimeData"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown trigger="click" placement="bottomRight">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: tableColumns.length * 180, y: 'calc(100vh - 480px)' }"
        :row-selection="{
          type: 'checkbox',
          columnWidth: '48px',
          selectedRowKeys: tableState.selectedRowKeys,
          onChange: fnTableSelectedRowKeys,
        }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'cause'">
            <span v-if="record.cdrJSON.result === 0">
              {{ t('views.dashboard.cdr.resultFail') }},
              <DictTag
                :options="dict.cdrCauseCode"
                :value="record.cdrJSON.cause"
                value-default="0"
              />
            </span>
            <span v-else>
              {{ t('views.dashboard.cdr.resultOk') }}
            </span>
          </template>
          <template v-if="column.key === 'id'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.copyText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordCopy(record.cdrJSON)"
                >
                  <template #icon>
                    <CopyOutlined />
                  </template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordDelete(record.id)"
                  v-perms:has="['cdr:ne:remove']"
                >
                  <template #icon>
                    <DeleteOutlined />
                  </template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
        <template #expandedRowRender="{ record }">
          <a-row :gutter="16">
            <a-col :lg="8" :md="12" :xs="24" :offset="2">
              <a-divider orientation="left">
                {{ t('views.dashboard.cdr.cdrInfo') }}
              </a-divider>
              <div>
                <span>{{ t('views.ne.common.neName') }}: </span>
                <span>{{ record.neName }}</span>
              </div>
              <div>
                <span>{{ t('views.ne.common.rmUid') }}: </span>
                <span>{{ record.rmUID }}</span>
              </div>
              <div>
                <span>{{ t('views.dashboard.cdr.time') }}: </span>
                <span>
                  {{
                    typeof record.cdrJSON.updateTime === 'number'
                      ? parseDateToStr(+record.cdrJSON.updateTime * 1000)
                      : record.cdrJSON.updateTime
                  }}
                </span>
              </div>
            </a-col>
            <a-col :lg="8" :md="12" :xs="24">
              <a-divider orientation="left">
                {{ t('views.dashboard.cdr.rowInfo') }}
              </a-divider>
              <div>
                <span>{{ t('views.dashboard.cdr.type') }}: </span>
                <span>{{ record.cdrJSON.serviceType }}</span>
              </div>
              <div>
                <span>{{ t('views.dashboard.cdr.caller') }}: </span>
                <span>{{ record.cdrJSON.callerParty }}</span>
              </div>
              <div>
                <span>{{ t('views.dashboard.cdr.called') }}: </span>
                <span>{{ record.cdrJSON.calledParty }}</span>
              </div>
              <div>
                <span>{{ t('views.dashboard.cdr.result') }}: </span>
                <span v-if="record.cdrJSON.result === 0">
                  {{ t('views.dashboard.cdr.resultFail') }},
                  <DictTag
                    :options="dict.cdrCauseCode"
                    :value="record.cdrJSON.cause"
                    value-default="0"
                  />
                </span>
                <span v-else>
                  {{ t('views.dashboard.cdr.resultOk') }}
                </span>
              </div>
            </a-col>
            <a-col
              :lg="16"
              :md="16"
              :xs="22"
              :offset="2"
              v-if="
                record.cdrJSON?.smsContent &&
                hasPermissions(['cdr:smsc:content'])
              "
            >
              <a-divider orientation="left"> Content </a-divider>
              <a-typography-paragraph
                copyable
                :content="record.cdrJSON.smsContent"
              >
              </a-typography-paragraph>
            </a-col>
          </a-row>
        </template>
      </a-table>
    </a-card>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
